#!/usr/bin/perl

sub hashCode {
	my $hash = 0;
	use integer;
	foreach(split //,shift) {
		$hash = 31*$hash+ord($_);
	}
	return $hash;
}

$HOME = $ENV{'HOME'};
$root = "$HOME/Library/Application\ Support/TagoMan/Terminal";
$data = "";

while (<STDIN>) {
	chomp ();
	s/\r/\n/g;
	$data .= "$_\n";
}

@a = split ('\n', $data);

$tty   = $a[0];
$title = $a[1];

@r = `ps -o command -t $tty`;

$cmd = $r[1];

if (! -d $root) {
	system ("mkdir '$root'");
}

$chksum = sprintf ("%X", hashCode ($title));

$name = "Terminal $title";
$name =~ s/[^A-Za-z0-9\:\.\- ]/_/g;
$name .= " -$chksum.command";

open (OUT, '>', "$root/$name") or die;
print (OUT "$cmd\n");
close (OUT);

system ("chmod 0755 '$root/$name'");
print ("$root/$name");
exit 0;
