#!/usr/bin/perl

sub hasMatchingDates {
	my ($f) = @_;
	
	if ($from ne "") {
		$DTSTART="DTSTART;.*:$fyear$fmon$fday"."T$from.*";
	}
	else {
		$DTSTART="DTSTART;.*:$fyear$fmon$fday".".*";
	}
	
	#print ("[$DTSTART]\n");
	open (IN, "< $f");
	while (<IN>) {
		chomp ();
		s/\r//g;
		#print ("[$_]\n");
		if ($_ =~ m/UID:(.*)/) {
			
		}
		elsif ($_ =~ /$DTSTART/) {
			close (IN);
			return $f;
		}
	}
	close (IN);
	return "";
}

$HOME = $ENV{'HOME'};
$root = "$HOME/Library/Calendars";
$data = "";
while (<STDIN>) {
	chomp ();
	s/\r/\n/g;
	$data .= "$_\n";
}

@a = split ('\n', $data);
#print ("$data");

$title = $a[0];
$date  = $a[1];

@d = split (' ', $date);

$fyear = "";
$fday  = "";
$fmon  = "";
$from = "";
$to   = "";

$tyear = "";
$tday  = "";
$tmon  = "";

$type = 1;

foreach (@d) {
	if ($_ eq "scheduled") {
	}
	elsif ($_ eq "from") {
		$from = "";
		$type = 1;
		next;
	}
	elsif ($_ eq "to") {
		$to = "";
		$type = 2;
		next;
	}
	elsif ($_ =~ m/(\d\d):(\d\d)/ && $type == 1) {
		$from = "$1$2";
		next;
	}
	elsif ($_ =~ m/(\d\d):(\d\d)/ && $type == 2) {
		$to = "$1$2";
		next;
	}
	
	if ($type == 2) {
		if ($_ =~ /\d\d\d\d/) {
			$tyear = $_;
		}
		elsif ($_ =~ /\d\d/) {
			$tday = $_;
		}
		elsif ($_ =~ /\d/) {
			$tday = "0$_";
		}
		elsif ($_ eq "January" || $_ eq "Jan") {
			$tmon = "01";
		}
		elsif ($_ eq "February" || $_ eq "Feb") {
			$tmon = "02";
		}
		elsif ($_ eq "March" || $_ eq "Mar") {
			$tmon = "03";
		}
		elsif ($_ eq "April" || $_ eq "Apr") {
			$tmon = "04";
		}
		elsif ($_ eq "May") {
			$tmon = "05";
		}
		elsif ($_ eq "June" || $_ eq "Jun") {
			$tmon = "06";
		}
		elsif ($_ eq "July" || $_ eq "Jul") {
			$tmon = "07";
		}
		elsif ($_ eq "August" || $_ eq "Aug") {
			$tmon = "08";
		}
		elsif ($_ eq "September" || $_ eq "Sep") {
			$tmon = "09";
		}
		elsif ($_ eq "October" || $_ eq "Oct") {
			$tmon = "10";
		}
		elsif ($_ eq "November" || $_ eq "Nov") {
			$tmon = "11";
		}
		elsif ($_ eq "December" || $_ eq "Dec") {
			$tmon = "12";
		}
	}
	if ($type == 1) {
		if ($_ =~ /\d\d\d\d/) {
			$fyear = $_;
		}
		elsif ($_ =~ /\d\d/) {
			$fday = $_;
		}
		elsif ($_ =~ /\d/) {
			$fday = "0$_";
		}
		elsif ($_ eq "January" || $_ eq "Jan") {
			$fmon = "01";
		}
		elsif ($_ eq "February" || $_ eq "Feb") {
			$fmon = "02";
		}
		elsif ($_ eq "March" || $_ eq "Mar") {
			$fmon = "03";
		}
		elsif ($_ eq "April" || $_ eq "Apr") {
			$fmon = "04";
		}
		elsif ($_ eq "May") {
			$fmon = "05";
		}
		elsif ($_ eq "June" || $_ eq "Jun") {
			$fmon = "06";
		}
		elsif ($_ eq "July" || $_ eq "Jul") {
			$fmon = "07";
		}
		elsif ($_ eq "August" || $_ eq "Aug") {
			$fmon = "08";
		}
		elsif ($_ eq "September" || $_ eq "Sep") {
			$fmon = "09";
		}
		elsif ($_ eq "October" || $_ eq "Oct") {
			$fmon = "10";
		}
		elsif ($_ eq "November" || $_ eq "Nov") {
			$fmon = "11";
		}
		elsif ($_ eq "December" || $_ eq "Dec") {
			$fmon = "12";
		}
	}
}
$SUMMARY = $title;
$SUMMARY =~ s/\\/\\\\/g;
$SUMMARY =~ s/'/\\'/g;
$SUMMARY =~ s/"/\\"/g;

if (length ($SUMMARY) > 60) {
	$SUMMARY = substr ($SUMMARY, 0, 60);
}
$f = "";
#$CMD="grep -Rl 'SUMMARY:$SUMMARY' $root/*";
$CMD="mdfind -onlyin $root \"kMDItemTitle == '$SUMMARY*'\"";
#print ("$CMD\n");
@rv = `$CMD`;
if ($#rv == 0) {
	chomp ($rv[0]);
	#print ("$rv[0]\n");
	if (-f $rv[0] && $rv[0] =~ /.ics$/) {
		print $rv[0] . "\n";
		exit 0;
	}
	else {
		exit 1;
	}
}
foreach (@rv) {
	chomp ();
	#print ("[$_]\n");
	if (-f $_ && $_ =~ /.ics$/ && ($f = hasMatchingDates ($_)) ne "") {
		print ("$f\n");
		exit 0;
	}
}
exit 1;
